#include "beremiz.h"
#ifndef __POUS_H
#define __POUS_H

#include "accessor.h"
#include "iec_std_lib.h"

__DECLARE_ENUMERATED_TYPE(LOGLEVEL,
  LOGLEVEL__CRITICAL,
  LOGLEVEL__WARNING,
  LOGLEVEL__INFO,
  LOGLEVEL__DEBUG
)
// FUNCTION_BLOCK LOGGER
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,TRIG)
  __DECLARE_VAR(STRING,MSG)
  __DECLARE_VAR(LOGLEVEL,LEVEL)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(BOOL,TRIG0)

} LOGGER;

void LOGGER_init__(LOGGER *data__, BOOL retain);
// Code part
void LOGGER_body__(LOGGER *data__);
// PROGRAM TMINTPLS
// Data part
typedef struct {
  // PROGRAM Interface - IN, OUT, IN_OUT variables

  // PROGRAM private variables - TEMP, private and located variables
  __DECLARE_LOCATED(BOOL,TMSW0)
  __DECLARE_LOCATED(BOOL,TMSW1)
  __DECLARE_LOCATED(BOOL,TMSW2)
  __DECLARE_LOCATED(BOOL,TMOUT0)
  __DECLARE_LOCATED(BOOL,TMOUT1)
  __DECLARE_LOCATED(BOOL,TMOUT2)
  TON TON0;
  TP TP0;
  TOF TOF0;

} TMINTPLS;

void TMINTPLS_init__(TMINTPLS *data__, BOOL retain);
// Code part
void TMINTPLS_body__(TMINTPLS *data__);
#endif //__POUS_H
